{% put scripts %}
<script type="text/javascript" src="{{ 'assets/vendor/d3/d3.min.js'|theme }}"></script>
<script type="text/javascript" src="{{ 'assets/vendor/lodash/lodash.min.js'|theme }}"></script>
<script>
    var default_width = 600;
    var default_height = 300;


    function set_vars() {
        var current_width = window.innerWidth;
        var current_height = window.innerHeight;


        if (current_width > 340 && current_width < 724) {
            width = 300;
            height = default_height;
        } else if (current_width < 340) {
            width = 250;
            height = 180;
        } else {
            width = default_width;
            height = default_height;

        }



    }

    set_vars();

    function drawGraphic(id, url, title) {

        var mar = 40;

        //const svg_width = width - margin.left - margin.right;
        //const svg_height = height - margin.top - margin.bottom;

        const svg_width = width;
        const svg_height = height;

        var chart_width = svg_width;
        var chart_height = svg_height - 2 * mar;



        var svg = d3.select(id).append("svg")
            .attr("width", svg_width)
            .attr("height", svg_height);

        svg.append("text")
            .attr("x", (width / 2))
            .attr("y", 20)
            .attr("text-anchor", "middle")
            .style("font-size", "16px")
            .style("text-decoration", "underline")
            .text(title);

        d3.json(url)
            .then((items) => {



                var xScale = d3
                    .scaleBand()
                    .range([0, chart_width])
                    .domain(items.map((s) => s.nama))
                    .padding(0.2);
                const bar_height = chart_height;

                var chart = svg
                    .append("g")
                    .attr("transform", `translate(${mar}, ${mar})`);

                var yScale = d3
                    .scaleLinear()
                    .range([bar_height, 0])
                    .domain([0, _.maxBy(items, "jumlah").jumlah]);

                /*
                var color = d3
                    .scaleLinear()
                    .range(["green", "blue", "red"])
                    .domain([
                        _.maxBy(items, "jumlah").jumlah,
                        _.minBy(items, "jumlah").jumlah,
                    ]);
                */

                var color = d3
                    .scaleOrdinal(["#4caf50", "#2196f3 ", "#f44336"]);

                chart.append("g").call(d3.axisLeft(yScale).ticks(10));
                chart
                    .append("g")
                    .attr("transform", `translate(0, ${bar_height})`)
                    .call(d3.axisBottom(xScale))
                    .selectAll(".tick text")
                    .call(wrap, xScale.bandwidth());

                var barGroups = chart.selectAll("rect").data(items).enter();
                barGroups
                    .append("rect")
                    .attr("fill", (g) => color(g.nama))
                    .attr("x", (g) => xScale(g.nama))
                    .attr("y", (g) => yScale(g.jumlah))
                    .attr("height", (g) => bar_height - yScale(g.jumlah))
                    .attr("width", xScale.bandwidth());




            });


    }



    function wrap(text, width) {
        text.each(function () {
            var text = d3.select(this),
                words = text.text().split(/\s+/).reverse(),
                word,
                line = [],
                lineNumber = 0,
                lineHeight = 1.1, // ems
                y = text.attr("y"),
                dy = parseFloat(text.attr("dy")),
                tspan = text.text(null).append("tspan").attr("x", 0).attr("y", y).attr("dy", dy + "em");
            while (word = words.pop()) {
                line.push(word);
                tspan.text(line.join(" "));
                if (tspan.node().getComputedTextLength() > width) {
                    line.pop();
                    tspan.text(line.join(" "));
                    line = [word];
                    tspan = text.append("tspan").attr("x", 0).attr("y", y).attr("dy", ++lineNumber *
                        lineHeight + dy + "em").text(word);
                }
            }
        });
    }

    drawGraphic("#chart_sekre", '/api/ikm/sekre', "Sekretariat");
    drawGraphic("#chart_penda", '/api/ikm/penda', "Penda Hindu");
    drawGraphic("#chart_pendis", '/api/ikm/pendis', "Pendidikan Islam");
    drawGraphic("#chart_haji", '/api/ikm/haji', "Haji dan Umrah");
    drawGraphic("#chart_budha", '/api/ikm/budha', "Penyelenggara Budha");
    drawGraphic("#chart_ura", '/api/ikm/ura', "Ura Hindu");
    drawGraphic("#chart_bimais", '/api/ikm/bimais', "Bimbingan Masyarakat Islam");

    var resizeTimer;

    window.onresize = function (event) {
        clearTimeout(resizeTimer);
        resizeTimer = setTimeout(function () {
            var s = d3.selectAll("svg");
            s = s.remove();
            set_vars();
            drawGraphic("#chart_sekre", '/api/ikm/Sekretariat', "Sekretariat");
            drawGraphic("#chart_penda", '/api/ikm/Sekretariat', "Penda Hindu");
            drawGraphic("#chart_pendis", '/api/ikm/Sekretariat', "Pendidikan Islam");
            drawGraphic("#chart_haji", '/api/ikm/Sekretariat', "Haji dan Umrah");
            drawGraphic("#chart_budha", '/api/ikm/Sekretariat', "Penyelenggara Budha");
            drawGraphic("#chart_ura", '/api/ikm/Sekretariat', "Ura Hindu");
            drawGraphic("#chart_bimais", '/api/ikm/Sekretariat', "Bimbingan Masyarakat Islam");
        }, 100);
    }


    function type(d) {
        d.value = +d.value;
        return d;
    }

</script>
{% endput %}

<style>
    svg {
        background: #eee;
    }

</style>


<div id="chart_sekre">
</div>
<br />
<div id="chart_penda">
</div>
<br />
<div id="chart_pendis">
</div>
<br />
<div id="chart_haji">
</div>
<br />
<div id="chart_budha">
</div>
<br />
<div id="chart_ura">
</div>
<br />
<div id="chart_bimais">
</div>
